# -*- coding: utf-8 -*-
# gui.py
# Umbau fuer Raumplaner-Klassenmethoden
import wx

from moebel import Moebel
## Es waere einfacher, wenn alle in einer Datei waeren
from badewanne import Badewanne
from bett import Bett
from dusche import Dusche
from herd import Herd
from klosett import Klosett
from sessel import Sessel
from schrank import Schrank
from sofa import Sofa
from stuhl import Stuhl
from tisch import Tisch
from ovalerTisch import OvalerTisch

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):
        
        wx.Frame.__init__(self, parent, ID, title, pos, (-1,360), style)
        panel = wx.Panel(self, -1)        

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.Append(103, "Bild-Export")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(104, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl")
        neuMenu.Append(202, "Tisch")
        neuMenu.Append(203, "Schrank")
        neuMenu.Append(204, "Sessel")
        neuMenu.Append(205, "Sofa")
        neuMenu.Append(207, "Ovaler Tisch")
        neuMenu.Append(206, "Bett")
        neuMenu.AppendSeparator()
        neuMenu.Append(210, "Badewanne")
        neuMenu.Append(211, "Dusche")
        neuMenu.Append(212, "Klosett")
        neuMenu.Append(213, "Herd")
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBildExport, id=103)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=104) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)
        self.Bind(wx.EVT_MENU, self.OnSessel, id=204)
        self.Bind(wx.EVT_MENU, self.OnSofa, id=205)
        self.Bind(wx.EVT_MENU, self.OnOvalerTisch, id=207)
        self.Bind(wx.EVT_MENU, self.OnBett, id=206)
        self.Bind(wx.EVT_MENU, self.OnBadewanne, id=210)
        self.Bind(wx.EVT_MENU, self.OnDusche, id=211)
        self.Bind(wx.EVT_MENU, self.OnKlosett, id=212)
        self.Bind(wx.EVT_MENU, self.OnHerd, id=213)

        ### Sizer
        gbs = self.gbs = wx.GridBagSizer(vgap=5, hgap=5)

        ### Abschnitt fuer StaticText und TextCtrl        
        label1 = wx.StaticText(panel, -1, "   x-Position", size=(155, -1))
        t1 = self.t1 = wx.TextCtrl(panel, -1, "", size=(155, -1))
        gbs.Add(label1, (0,0), flag=wx.ALL, border=15)
        gbs.Add(t1, (0,1), flag=wx.ALL, border=5)
        
        label2 = wx.StaticText(panel, -1, "   y-Position", size=(155, -1))
        t2 = self.t2 = wx.TextCtrl(panel, -1, "", size=(155, -1))
        gbs.Add(label2, (1,0), flag=wx.ALL, border=15)
        gbs.Add(t2, (1,1), flag=wx.ALL, border=5)

        label3 = wx.StaticText(panel, -1, "   Winkel", size=(155, -1))
        t3 = self.t3 = wx.TextCtrl(panel, -1, "", size=(155, -1))
        gbs.Add(label3, (2,0), flag=wx.ALL, border=15)
        gbs.Add(t3, (2,1), flag=wx.ALL, border=5)

        label4 = wx.StaticText(panel, -1, "   Farbe", size=(155, -1))
        t4 = self.t4 = wx.TextCtrl(panel, -1, "", size=(155, -1))
        gbs.Add(label4, (3,0), flag=wx.ALL, border=15)
        gbs.Add(t4, (3,1), flag=wx.ALL, border=5)

        ### Button-Abschnitt
        waehleButton = wx.Button(panel, -1, u"Wählen")
        gbs.Add(waehleButton, (4,0), flag=wx.ALL, border=15)
        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        gbs.Add(beendenButton, (4,1), flag=wx.ALL, border=15)
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        panel.SetSizerAndFit(gbs)
        

    ### Ereignisbehandlung ###
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        Moebel.Oeffnen("Daten/daten.dat")

    def OnSpeichern(self, event):
        Moebel.Speichern("Daten/daten.dat")

    def OnBildExport(self, event):
        Moebel.BildExport("Bilder/Bild.png")

    def OnStuhl(self, event):
        Stuhl(10, 30, 40, 40, 270, 'blue', True)

    def OnTisch(self, event):
        Tisch(60, 20, 120, 60, 0, 'red', True)

    def OnSchrank(self, event):
        Schrank(280, 40, 100, 60, 90, 'brown', True)

    def OnSessel(self, event):
        Sessel(100, 130, 60, 60, 0, 'orange', True)

    def OnSofa(self, event):
        Sofa(70, 290, 120, 60, 180, 'orange', True)

    def OnOvalerTisch(self, event):
        OvalerTisch(70, 200, 120, 80, 0, 'brown', True)

    def OnBett(self, event):
        Bett(380, 20, sichtbar=True)

    def OnBadewanne(self, event):
        Badewanne(20, 440, sichtbar=True)

    def OnDusche(self, event):
        Dusche(300, 440, sichtbar=True)

    def OnKlosett(self, event):
        Klosett(500, 440, sichtbar=True)

    def OnHerd(self, event):
        Herd(500, 300, sichtbar=True)


    ### Button-Abschnitt
    def OnWaehle(self, event):
        Moebel.Waehle()
        self.UpdateDaten()

    def UpdateDaten(self):
        if Moebel.GibAusgewaehltes()==None:
            self.t1.SetValue("")
            self.t2.SetValue("")
            self.t3.SetValue("")
            self.t4.SetValue("")
        else:
            daten=Moebel.GibAktuelleDaten()
            self.t1.SetValue(str(daten[0]))
            self.t2.SetValue(str(daten[1]))
            self.t3.SetValue(str(daten[2]))
            self.t4.SetValue(daten[3])

    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
